From c8d70e11a5351d3b2a17fa91e84e7733da9fa27e Mon Sep 17 00:00:00 2001
From: Jorge Chamorro Bieling <jorge@jorgechamorro.com>
Date: Fri, 4 Mar 2011 10:02:01 +0100
Subject: [PATCH] disallow repeated event handlers

---
 lib/events.js |    8 ++++++--
 1 files changed, 6 insertions(+), 2 deletions(-)

diff --git a/lib/events.js b/lib/events.js
index 6505606..f0045d5 100644
--- a/lib/events.js
+++ b/lib/events.js
@@ -103,10 +103,14 @@ EventEmitter.prototype.addListener = function(type, listener) {
     }
 
     // If we've already got an array, just append.
-    this._events[type].push(listener);
+    if (this._events[type].indexOf(listener) < 0) {
+      this._events[type].push(listener);
+    }
   } else {
     // Adding the second element, need to change to array.
-    this._events[type] = [this._events[type], listener];
+    if (this._events[type] !== listener) {
+      this._events[type] = [this._events[type], listener];
+    }
   }
 
   return this;
-- 
1.7.1

